diff --git a/locale/iso-4217.def b/locale/iso-4217.def
index 414f69b..84cebb9 100644
--- a/locale/iso-4217.def
+++ b/locale/iso-4217.def
@@ -138,6 +138,7 @@ DEFINE_INT_CURR("SHP")		/* St. Helena Pound  */
 DEFINE_INT_CURR("SLL")		/* Sierra Leone Leone  */
 DEFINE_INT_CURR("SOS")		/* Somalia Schilling  */
 DEFINE_INT_CURR("SRD")		/* Suriname Dollar  */
+DEFINE_INT_CURR("SSP")		/* South Sudanese Pound  */
 DEFINE_INT_CURR("STD")		/* Sao Tome and Principe Dobra  */
 DEFINE_INT_CURR("SVC")		/* El Salvador Colon  */
 DEFINE_INT_CURR("SYP")		/* Syrian Arab Republic Pound  */
@@ -167,5 +168,5 @@ DEFINE_INT_CURR("XOF")		/* West African Franc (Benin, Ivory Coast, Niger, Senega
 DEFINE_INT_CURR("XPF")		/* French polynesia, New Caledonia, Wallis and Futuna Islands  */
 DEFINE_INT_CURR("YER")		/* Yemeni Rial  */
 DEFINE_INT_CURR("ZAR")		/* South Africa Rand (Lesotho, Namibia)  */
-DEFINE_INT_CURR("ZMK")		/* Zambian Kwacha  */
+DEFINE_INT_CURR("ZMW")		/* Zambian Kwacha  */
 DEFINE_INT_CURR("ZWD")		/* Zimbabwe Dollar  */
diff --git a/localedata/locales/aa_DJ b/localedata/locales/aa_DJ
index f11b746..0cd8353 100644
--- a/localedata/locales/aa_DJ
+++ b/localedata/locales/aa_DJ
@@ -89,7 +89,7 @@ END LC_MEASUREMENT
 LC_MONETARY
 %
 int_curr_symbol       "<U0044><U004A><U0046><U0020>"
-currency_symbol       "<U0024>"
+currency_symbol       "<U0046><U0064><U006A>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U0020>"
 mon_grouping          3;3
diff --git a/localedata/locales/ar_SA b/localedata/locales/ar_SA
index f9a5c1f..cbae151 100644
--- a/localedata/locales/ar_SA
+++ b/localedata/locales/ar_SA
@@ -273,7 +273,7 @@ END LC_COLLATE
 
 LC_MONETARY
 int_curr_symbol	"<U0053><U0041><U0052><U0020>"
-currency_symbol	"<U0631><U064A><U0627><U0644>"
+currency_symbol	"<U0631><U002E><U0633>"
 mon_decimal_point	"<U002E>"
 mon_thousands_sep	""
 mon_grouping	-1
diff --git a/localedata/locales/ar_SS b/localedata/locales/ar_SS
index bab3e3b..a1b7427 100644
--- a/localedata/locales/ar_SS
+++ b/localedata/locales/ar_SS
@@ -61,9 +61,8 @@ LC_MONETARY
 % These are generated based on XML base Locale definition file
 % for IBM Class for Unicode/Java
 %
-% SDG
-int_curr_symbol       "<U0053><U0044><U0047><U0020>"
-currency_symbol       "<U062C><U002E><U0633><U002E>"
+int_curr_symbol       "<U0053><U0053><U0050><U0020>"
+currency_symbol       "<U00A3>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
 mon_grouping          3
diff --git a/localedata/locales/az_AZ b/localedata/locales/az_AZ
index e23a1fc..b08f1aa 100644
--- a/localedata/locales/az_AZ
+++ b/localedata/locales/az_AZ
@@ -214,7 +214,7 @@ END LC_MESSAGES
 LC_MONETARY
 % AZN
 int_curr_symbol           "<U0041><U005A><U004E><U0020>"
-currency_symbol           "<U006D><U0061><U006E><U002E>"
+currency_symbol           "<U20BC>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U0020>"
 mon_grouping              3;3
diff --git a/localedata/locales/bem_ZM b/localedata/locales/bem_ZM
index d0e5eca..96dafad 100644
--- a/localedata/locales/bem_ZM
+++ b/localedata/locales/bem_ZM
@@ -120,8 +120,8 @@ END LC_NUMERIC
 LC_MONETARY
 % K
 currency_symbol  "<U004B>"
-% ZMK
-int_curr_symbol  "<U005A><U004D><U004B><U0020>"
+% ZMW
+int_curr_symbol  "<U005A><U004D><U0057><U0020>"
 % .
 mon_decimal_point  "<U002E>"
 % ,
diff --git a/localedata/locales/bg_BG b/localedata/locales/bg_BG
index cfb86dc..38d7dcc 100644
--- a/localedata/locales/bg_BG
+++ b/localedata/locales/bg_BG
@@ -163,7 +163,7 @@ END LC_COLLATE
 
 LC_MONETARY
 int_curr_symbol           "<U0042><U0047><U004E><U0020>"
-currency_symbol           "<U043B><U0432>"
+currency_symbol           "<U043B><U0432><U002E>"
 mon_decimal_point         "<U002C>"
 mon_thousands_sep         "<U00A0>"
 mon_grouping              3;3
diff --git a/localedata/locales/ce_RU b/localedata/locales/ce_RU
index db30c62..e1be56c 100644
--- a/localedata/locales/ce_RU
+++ b/localedata/locales/ce_RU
@@ -109,7 +109,7 @@ END LC_NUMERIC
 LC_MONETARY
 % RUB
 int_curr_symbol    "<U0052><U0055><U0042><U0020>"
-currency_symbol    "<U0440><U0443><U0431>"
+currency_symbol    "<U20BD>"
 % .
 mon_decimal_point  "<U002E>"
 mon_thousands_sep  "<U00A0>"
diff --git a/localedata/locales/crh_UA b/localedata/locales/crh_UA
index ebeffbf..6785727 100644
--- a/localedata/locales/crh_UA
+++ b/localedata/locales/crh_UA
@@ -137,7 +137,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0055><U0041><U0048><U0020>"
-currency_symbol           "<U0067><U0072>"
+currency_symbol           "<U20B4>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U0020>"
 mon_grouping              3;3
diff --git a/localedata/locales/cv_RU b/localedata/locales/cv_RU
index 5ba0847..1a91f53 100644
--- a/localedata/locales/cv_RU
+++ b/localedata/locales/cv_RU
@@ -123,7 +123,7 @@ LC_MONETARY
 int_curr_symbol           "<U0052><U0055><U0042><U0020>"
 
 % "t." - short for tenke(, Chuvash name for rouble
-currency_symbol "<U0074>"
+currency_symbol "<U20BD>"
 
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U00A0>"
diff --git a/localedata/locales/de_CH b/localedata/locales/de_CH
index 98c83b8..7905af5 100644
--- a/localedata/locales/de_CH
+++ b/localedata/locales/de_CH
@@ -63,7 +63,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0043><U0048><U0046><U0020>"
-currency_symbol           "<U0046><U0072><U002E>"
+currency_symbol           "<U0043><U0048><U0046>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U0027>"
 mon_grouping              3;3
diff --git a/localedata/locales/dz_BT b/localedata/locales/dz_BT
index 678b4bd..b4bdeca 100644
--- a/localedata/locales/dz_BT
+++ b/localedata/locales/dz_BT
@@ -519,8 +519,8 @@ END LC_COLLATE
 
 LC_MONETARY
 
-int_curr_symbol         "<U0042><U0054><U004E> "
-currency_symbol    "<U0F51><U0F44><U0F74><U0F63><U0F0B><U0F40><U0FB2><U0F58><U0F0B>"
+int_curr_symbol         "<U0042><U0054><U004E><U0020>"
+currency_symbol    "<U004E><U0075><U002E>"
 mon_decimal_point       "<U002E>"
 mon_thousands_sep       "<U002C>"
 mon_grouping            3;2;
diff --git a/localedata/locales/en_BW b/localedata/locales/en_BW
index c67e1ec..018f241 100644
--- a/localedata/locales/en_BW
+++ b/localedata/locales/en_BW
@@ -57,7 +57,7 @@ END LC_COLLATE
 
 LC_MONETARY
 int_curr_symbol         "<U0042><U0057><U0050><U0020>"
-currency_symbol         "<U0050><U0075>"
+currency_symbol         "<U0050>"
 mon_decimal_point       "<U002E>"
 mon_thousands_sep       "<U002C>"
 mon_grouping            3;3
diff --git a/localedata/locales/en_DK b/localedata/locales/en_DK
index 8e9db1c..d12b358 100644
--- a/localedata/locales/en_DK
+++ b/localedata/locales/en_DK
@@ -65,7 +65,7 @@ END LC_CTYPE
 
 LC_MONETARY
 int_curr_symbol      "<U0044><U004B><U004B><U0020>"
-currency_symbol      "<U00A4>"
+currency_symbol      "<U006B><U0072><U002E>"
 mon_decimal_point    "<U002C>"
 mon_thousands_sep    "<U002E>"
 mon_grouping         3;3
diff --git a/localedata/locales/en_PH b/localedata/locales/en_PH
index bf2f680..cebeacf 100644
--- a/localedata/locales/en_PH
+++ b/localedata/locales/en_PH
@@ -61,7 +61,7 @@ LC_MONETARY
 % for IBM Class for Unicode.
 %
 int_curr_symbol       "<U0050><U0048><U0050><U0020>"
-currency_symbol       "<U0050><U0068><U0070>"
+currency_symbol       "<U20B1>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
 mon_grouping          3
diff --git a/localedata/locales/en_ZW b/localedata/locales/en_ZW
index 7109fa2..28d043f 100644
--- a/localedata/locales/en_ZW
+++ b/localedata/locales/en_ZW
@@ -56,8 +56,8 @@ copy "en_ZA"
 END LC_COLLATE
 
 LC_MONETARY
-int_curr_symbol         "<U005A><U0057><U0044><U0020>"
-currency_symbol         "<U005A><U0024>"
+int_curr_symbol         "<U0055><U0053><U0044><U0020>"
+currency_symbol         "<U0024>"
 mon_decimal_point       "<U002E>"
 mon_thousands_sep       "<U002C>"
 mon_grouping            3;3
diff --git a/localedata/locales/es_BO b/localedata/locales/es_BO
index 6984aa2..d153ce6 100644
--- a/localedata/locales/es_BO
+++ b/localedata/locales/es_BO
@@ -65,7 +65,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol      "<U0042><U004F><U0042><U0020>"
-currency_symbol      "<U0024><U0062>"
+currency_symbol      "<U0042><U0073>"
 mon_decimal_point    "<U002C>"
 mon_thousands_sep    "<U002E>"
 mon_grouping         3;3
diff --git a/localedata/locales/es_DO b/localedata/locales/es_DO
index 791d492..7de249b 100644
--- a/localedata/locales/es_DO
+++ b/localedata/locales/es_DO
@@ -65,7 +65,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol      "<U0044><U004F><U0050><U0020>"
-currency_symbol      "<U0024>"
+currency_symbol      "<U0052><U0044><U0024>"
 mon_decimal_point    "<U002E>"
 mon_thousands_sep    "<U002C>"
 mon_grouping         3;3
diff --git a/localedata/locales/es_HN b/localedata/locales/es_HN
index 98ee473..de18ee3 100644
--- a/localedata/locales/es_HN
+++ b/localedata/locales/es_HN
@@ -65,7 +65,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol      "<U0048><U004E><U004C><U0020>"
-currency_symbol      "<U004C><U002E>"
+currency_symbol      "<U004C>"
 mon_decimal_point    "<U002E>"
 mon_thousands_sep    "<U002C>"
 mon_grouping         3;3
diff --git a/localedata/locales/es_PA b/localedata/locales/es_PA
index 6d867cb..eff6bc0 100644
--- a/localedata/locales/es_PA
+++ b/localedata/locales/es_PA
@@ -65,7 +65,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol      "<U0050><U0041><U0042><U0020>"
-currency_symbol      "<U0042><U002F>"
+currency_symbol      "<U0042><U002F><U002E>"
 mon_decimal_point    "<U002E>"
 mon_thousands_sep    "<U002C>"
 mon_grouping         3;3
diff --git a/localedata/locales/es_SV b/localedata/locales/es_SV
index c6874e0..00d49c7 100644
--- a/localedata/locales/es_SV
+++ b/localedata/locales/es_SV
@@ -64,8 +64,8 @@ copy "es_ES"
 END LC_MESSAGES
 
 LC_MONETARY
-int_curr_symbol      "<U0053><U0056><U0043><U0020>"
-currency_symbol      "<U20A1>"
+int_curr_symbol      "<U0055><U0053><U0044><U0020>"
+currency_symbol      "<U0024>"
 mon_decimal_point    "<U002E>"
 mon_thousands_sep    "<U002C>"
 mon_grouping         3;3
diff --git a/localedata/locales/fil_PH b/localedata/locales/fil_PH
index 0e4686f..26ea6e1 100644
--- a/localedata/locales/fil_PH
+++ b/localedata/locales/fil_PH
@@ -89,7 +89,7 @@ END LC_COLLATE
 
 LC_MONETARY
 int_curr_symbol         "<U0050><U0048><U0050><U0020>"
-currency_symbol         "<U0050><U0068><U0050>"
+currency_symbol         "<U20B1>"
 mon_decimal_point       "<U002E>"
 mon_thousands_sep       "<U002C>"
 mon_grouping            3;3
diff --git a/localedata/locales/he_IL b/localedata/locales/he_IL
index c5bca56..aca5703 100644
--- a/localedata/locales/he_IL
+++ b/localedata/locales/he_IL
@@ -68,7 +68,7 @@ END LC_COLLATE
 
 LC_MONETARY
 int_curr_symbol   "<U0049><U004C><U0053><U0020>"
-currency_symbol   "<U05E9><U05D7>"
+currency_symbol   "<U20AA>"
 mon_decimal_point "<U002E>"
 mon_thousands_sep "<U002C>"
 mon_grouping      3;3
diff --git a/localedata/locales/hy_AM b/localedata/locales/hy_AM
index cb24c84..1ed66c4 100644
--- a/localedata/locales/hy_AM
+++ b/localedata/locales/hy_AM
@@ -87,7 +87,7 @@ END LC_CTYPE
 
 LC_MONETARY
 int_curr_symbol      "<U0041><U004D><U0044><U0020>"
-currency_symbol      "<U0534>"
+currency_symbol      "<U058F>"
 mon_decimal_point    "<U002E>"
 mon_thousands_sep    "<U002C>"
 mon_grouping         3;3
diff --git a/localedata/locales/ka_GE b/localedata/locales/ka_GE
index cdf66bd..cdefb56 100644
--- a/localedata/locales/ka_GE
+++ b/localedata/locales/ka_GE
@@ -73,7 +73,7 @@ END LC_CTYPE
 
 LC_MONETARY
 int_curr_symbol      "<U0047><U0045><U004C><U0020>"
-currency_symbol      "<U10DA>"
+currency_symbol      "<U20BE>"
 mon_decimal_point    "<U002C>"
 mon_thousands_sep    "<U002E>"
 mon_grouping         3;3
diff --git a/localedata/locales/kk_KZ b/localedata/locales/kk_KZ
index 55659ec..175c3c8 100644
--- a/localedata/locales/kk_KZ
+++ b/localedata/locales/kk_KZ
@@ -167,7 +167,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U004B><U005A><U0054><U0020>"
-currency_symbol           "<U0442><U0433>"
+currency_symbol           "<U20B8>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U0020>"
 mon_grouping              3;3
diff --git a/localedata/locales/ko_KR b/localedata/locales/ko_KR
index 2cde2d9..9452d24 100644
--- a/localedata/locales/ko_KR
+++ b/localedata/locales/ko_KR
@@ -6106,7 +6106,7 @@ END LC_CTYPE
 LC_MONETARY
 
 int_curr_symbol		"<U004B><U0052><U0057><U0020>"
-currency_symbol		"<UFFE6>"
+currency_symbol		"<U20A9>"
 mon_decimal_point	"<U002E>"
 mon_thousands_sep	"<U002C>"
 mon_grouping		3;3
diff --git a/localedata/locales/lg_UG b/localedata/locales/lg_UG
index ae8f284..688e015 100644
--- a/localedata/locales/lg_UG
+++ b/localedata/locales/lg_UG
@@ -71,7 +71,7 @@ LC_MONETARY
 int_curr_symbol         "<U0055><U0047><U0058><U0020>"
 % International currency symbol "UGX"
 %
-currency_symbol         "<U002F><U002D>"
+currency_symbol         "<U0055><U0053><U0068>"
 % Local currency symbol "/-"
 %
 mon_decimal_point       "<U002E>"
diff --git a/localedata/locales/lv_LV b/localedata/locales/lv_LV
index 4ac1c66..e773c98 100644
--- a/localedata/locales/lv_LV
+++ b/localedata/locales/lv_LV
@@ -2126,8 +2126,8 @@ translit_end
 END LC_CTYPE
 
 LC_MONETARY
-int_curr_symbol   "<U004C><U0056><U004C><U0020>"
-currency_symbol   "<U004C><U0073>"
+int_curr_symbol   "<U0045><U0055><U0052><U0020>"
+currency_symbol   "<U20AC>"
 mon_decimal_point "<U002C>"
 mon_thousands_sep "<U00A0>"
 mon_grouping      3;3
diff --git a/localedata/locales/mg_MG b/localedata/locales/mg_MG
index 248082b..b090e51 100644
--- a/localedata/locales/mg_MG
+++ b/localedata/locales/mg_MG
@@ -73,7 +73,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U004D><U0047><U0041><U0020>"
-currency_symbol           "<U0041><U0052>"
+currency_symbol           "<U0041><U0072>"
 mon_decimal_point         "<U002C>"
 mon_thousands_sep         "<U0020>"
 mon_grouping              3;3
diff --git a/localedata/locales/mhr_RU b/localedata/locales/mhr_RU
index 29e3ba8..83bac50 100644
--- a/localedata/locales/mhr_RU
+++ b/localedata/locales/mhr_RU
@@ -69,7 +69,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0052><U0055><U0042><U0020>"
-currency_symbol           "<U0422><U0415><U04A4>"
+currency_symbol           "<U20BD>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U00A0>"
 mon_grouping              3;3
diff --git a/localedata/locales/my_MM b/localedata/locales/my_MM
index 942aeb2..44fc7d8 100644
--- a/localedata/locales/my_MM
+++ b/localedata/locales/my_MM
@@ -73,7 +73,7 @@ int_curr_symbol     "<U004D><U004D><U004B><U0020>"
 % Kyat in Burmese - it would be better to use this if Myanmar digits are used
 % currency_symbol         "<U1000><U103B><U1015><U103A>"
 % Ks
-currency_symbol "<U004B><U0073>"
+currency_symbol "<U004B>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
 mon_grouping          3;3
diff --git a/localedata/locales/ne_NP b/localedata/locales/ne_NP
index d1c7533..83070bb 100644
--- a/localedata/locales/ne_NP
+++ b/localedata/locales/ne_NP
@@ -56,7 +56,7 @@ LC_MONETARY
 % These are generated based on XML base Locale definition file
 % for IBM Class for Unicode/Java
 %
-int_curr_symbol       "<U0049><U004E><U0052><U0020>"
+int_curr_symbol       "<U004E><U0050><U0052><U0020>"
 currency_symbol       "<U0930><U0942>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
diff --git a/localedata/locales/os_RU b/localedata/locales/os_RU
index b4d5e6b..3dd94cb 100644
--- a/localedata/locales/os_RU
+++ b/localedata/locales/os_RU
@@ -81,7 +81,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0052><U0055><U0042><U0020>"
-currency_symbol           "<U0441><U043E><U043C>"
+currency_symbol           "<U20BD>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U00A0>"
 mon_grouping              3;3
diff --git a/localedata/locales/pap_AW b/localedata/locales/pap_AW
index ff72208..805acb5 100644
--- a/localedata/locales/pap_AW
+++ b/localedata/locales/pap_AW
@@ -83,8 +83,8 @@ END LC_MESSAGES
 
 
 LC_MONETARY
-int_curr_symbol           "<U0041><U004E><U0047><U0020>"
-currency_symbol           "<U0066>"
+int_curr_symbol           "<U0041><U0057><U0047><U0020>"
+currency_symbol           "<U0192>"
 mon_decimal_point         "<U002C>"
 mon_thousands_sep         "<U0020>"
 mon_grouping              3;3
diff --git a/localedata/locales/pap_CW b/localedata/locales/pap_CW
index f62a730..8f38915 100644
--- a/localedata/locales/pap_CW
+++ b/localedata/locales/pap_CW
@@ -84,7 +84,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0041><U004E><U0047><U0020>"
-currency_symbol           "<U0066>"
+currency_symbol           "<U0192>"
 mon_decimal_point         "<U002C>"
 mon_thousands_sep         "<U0020>"
 mon_grouping              3;3
diff --git a/localedata/locales/ps_AF b/localedata/locales/ps_AF
index 64686ee..92b7b0f 100644
--- a/localedata/locales/ps_AF
+++ b/localedata/locales/ps_AF
@@ -212,7 +212,7 @@ END LC_NUMERIC
 
 LC_MONETARY
 int_curr_symbol	"<U0041><U0046><U004E><U0020>"
-currency_symbol	"<U0627><U0641><U063A><U0627><U0646><U06CD>"
+currency_symbol	"<U060B>"
 mon_decimal_point	"<U066B>"
 mon_thousands_sep	"<U066C>"
 mon_grouping	3
diff --git a/localedata/locales/ru_RU b/localedata/locales/ru_RU
index f2cf310..87d83ca 100644
--- a/localedata/locales/ru_RU
+++ b/localedata/locales/ru_RU
@@ -84,7 +84,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0052><U0055><U0042><U0020>"
-currency_symbol           "<U0440><U0443><U0431>"
+currency_symbol           "<U20BD>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U00A0>"
 mon_grouping              3;3
diff --git a/localedata/locales/ru_UA b/localedata/locales/ru_UA
index f514570..16037c0 100644
--- a/localedata/locales/ru_UA
+++ b/localedata/locales/ru_UA
@@ -76,7 +76,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0055><U0041><U0048><U0020>"
-currency_symbol           "<U0433><U0440>"
+currency_symbol           "<U20B4>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U0020>"
 mon_grouping              3;3
diff --git a/localedata/locales/rw_RW b/localedata/locales/rw_RW
index 16841fa..aca036d 100644
--- a/localedata/locales/rw_RW
+++ b/localedata/locales/rw_RW
@@ -57,7 +57,7 @@ END LC_COLLATE
 
 LC_MONETARY
 int_curr_symbol           "<U0052><U0057><U0046><U0020>"
-currency_symbol           "<U0046><U0072><U0077>"
+currency_symbol           "<U0046><U0052><U0077>"
 mon_decimal_point         "<U002C>"
 mon_thousands_sep         "<U002E>"
 mon_grouping              3;3
diff --git a/localedata/locales/sd_IN@devanagari b/localedata/locales/sd_IN@devanagari
index c9a361e..913d0d9 100644
--- a/localedata/locales/sd_IN@devanagari
+++ b/localedata/locales/sd_IN@devanagari
@@ -61,7 +61,7 @@ LC_MONETARY
 % for IBM Class for Unicode.
 %
 int_curr_symbol       "<U0049><U004E><U0052><U0020>"
-currency_symbol       "<U0930><U0941>"
+currency_symbol       "<U20B9>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
 mon_grouping          3
diff --git a/localedata/locales/se_NO b/localedata/locales/se_NO
index 72f8819..e8f728f 100644
--- a/localedata/locales/se_NO
+++ b/localedata/locales/se_NO
@@ -210,7 +210,7 @@ END LC_CTYPE
 
 LC_MONETARY
 int_curr_symbol         "<U004E><U004F><U004B><U0020>"
-currency_symbol         "<U0020><U0072><U0075>"
+currency_symbol         "<U006B><U0072>"
 mon_decimal_point       "<U002C>"
 mon_thousands_sep       "<U002E>"
 mon_grouping            3;3
diff --git a/localedata/locales/si_LK b/localedata/locales/si_LK
index 7a2cf47..d1d4784 100644
--- a/localedata/locales/si_LK
+++ b/localedata/locales/si_LK
@@ -60,7 +60,7 @@ LC_MONETARY
 % This is the POSIX Locale definition the LC_MONETARY category
 %
 int_curr_symbol       "<U004C><U004B><U0052><U0020>"
-currency_symbol       "<U20A8>"
+currency_symbol       "<U0DBB><U0DD4>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
 mon_grouping          3
diff --git a/localedata/locales/so_SO b/localedata/locales/so_SO
index 8b68866..5392e44 100644
--- a/localedata/locales/so_SO
+++ b/localedata/locales/so_SO
@@ -89,7 +89,7 @@ END LC_MEASUREMENT
 LC_MONETARY
 %
 int_curr_symbol       "<U0053><U004F><U0053><U0020>"
-currency_symbol       "<U0024>"
+currency_symbol       "<U0053>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
 mon_grouping          3;3
diff --git a/localedata/locales/sq_AL b/localedata/locales/sq_AL
index eb1a8cb..929aeed 100644
--- a/localedata/locales/sq_AL
+++ b/localedata/locales/sq_AL
@@ -201,7 +201,7 @@ LC_MONETARY
 % for IBM Class for Unicode/Java
 %
 int_curr_symbol       "<U0041><U004C><U004C><U0020>"
-currency_symbol       "<U004C><U0065><U006B>"
+currency_symbol       "<U004C>"
 mon_decimal_point     "<U002C>"
 mon_thousands_sep     "<U002E>"
 mon_grouping          3
diff --git a/localedata/locales/the_NP b/localedata/locales/the_NP
index 2c6c5af..df44885 100644
--- a/localedata/locales/the_NP
+++ b/localedata/locales/the_NP
@@ -57,7 +57,7 @@ LC_MONETARY
 % These are generated based on XML base Locale definition file
 % for IBM Class for Unicode/Java
 %
-int_curr_symbol       "<U0049><U004E><U0052><U0020>"
+int_curr_symbol       "<U004E><U0050><U0052><U0020>"
 currency_symbol       "<U0930><U0942>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
diff --git a/localedata/locales/ti_ER b/localedata/locales/ti_ER
index cb2b4ff..0bdcae9 100644
--- a/localedata/locales/ti_ER
+++ b/localedata/locales/ti_ER
@@ -83,7 +83,7 @@ END LC_MEASUREMENT
 LC_MONETARY
 %
 int_curr_symbol       "<U0045><U0052><U004E><U0020>"
-currency_symbol       "<U0024>"
+currency_symbol       "<U004E><U0066><U006B>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
 mon_grouping          3;3
diff --git a/localedata/locales/ti_ET b/localedata/locales/ti_ET
index a3d5118..162643a 100644
--- a/localedata/locales/ti_ET
+++ b/localedata/locales/ti_ET
@@ -886,7 +886,7 @@ END LC_MEASUREMENT
 LC_MONETARY
 %
 int_curr_symbol       "<U0045><U0054><U0042><U0020>"
-currency_symbol       "<U0024>"
+currency_symbol       "<U0042><U0072>"
 mon_decimal_point     "<U002E>"
 mon_thousands_sep     "<U002C>"
 mon_grouping          3;3
diff --git a/localedata/locales/tl_PH b/localedata/locales/tl_PH
index a865bee..c30ea7b 100644
--- a/localedata/locales/tl_PH
+++ b/localedata/locales/tl_PH
@@ -85,7 +85,7 @@ END LC_COLLATE
 
 LC_MONETARY
 int_curr_symbol         "<U0050><U0048><U0050><U0020>"
-currency_symbol         "<U0050><U0068><U0050>"
+currency_symbol         "<U20B1>"
 mon_decimal_point       "<U002E>"
 mon_thousands_sep       "<U002C>"
 mon_grouping            3;3
diff --git a/localedata/locales/tr_TR b/localedata/locales/tr_TR
index 1025e97..62b8fd0 100644
--- a/localedata/locales/tr_TR
+++ b/localedata/locales/tr_TR
@@ -4247,7 +4247,7 @@ LC_MONETARY
 % ISO-4217 (2004-10-25): TRY 949 2
 int_curr_symbol           "<U0054><U0052><U0059><U0020>"
 % TL
-currency_symbol           "<U0054><U004C>"
+currency_symbol           "<U20BA>"
 mon_decimal_point         "<U002C>"
 mon_thousands_sep         "<U002E>"
 mon_grouping              3;3
diff --git a/localedata/locales/tt_RU b/localedata/locales/tt_RU
index ba67c4d..60c8e29 100644
--- a/localedata/locales/tt_RU
+++ b/localedata/locales/tt_RU
@@ -237,7 +237,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0052><U0055><U0042><U0020>"
-currency_symbol           "<U0440><U0443><U0431>"
+currency_symbol           "<U20BD>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U0020>"
 mon_grouping              3;3
diff --git a/localedata/locales/tt_RU@iqtelif b/localedata/locales/tt_RU@iqtelif
index 61ac1fb..98217eb 100644
--- a/localedata/locales/tt_RU@iqtelif
+++ b/localedata/locales/tt_RU@iqtelif
@@ -86,7 +86,7 @@ END LC_MESSAGES
 
 LC_MONETARY
 int_curr_symbol           "<U0052><U0055><U0042><U0020>"
-currency_symbol           "<U0073><U0075><U006D>"
+currency_symbol           "<U20BD>"
 mon_decimal_point         "<U002E>"
 mon_thousands_sep         "<U2002>"
 mon_grouping              3;3
diff --git a/localedata/locales/uz_UZ b/localedata/locales/uz_UZ
index 6681b36..6eac7fc 100644
--- a/localedata/locales/uz_UZ
+++ b/localedata/locales/uz_UZ
@@ -207,7 +207,7 @@ END LC_COLLATE
 
 LC_MONETARY
 int_curr_symbol         "<U0055><U005A><U0053><U0020>"
-currency_symbol         "<U0073><U006F><U0027><U006D>"
+currency_symbol         "<U0073><U006F><U02BB><U006D>"
 mon_decimal_point       "<U002E>"
 mon_thousands_sep       "<U002C>"
 mon_grouping            3;3