diff --git a/locale/iso-639.def b/locale/iso-639.def
index 926aebada0..98c2ad89ea 100644
--- a/locale/iso-639.def
+++ b/locale/iso-639.def
@@ -400,6 +400,7 @@ DEFINE_LANGUAGE_CODE ("Raeto-Romance", rm, roh, roh)
 DEFINE_LANGUAGE_CODE3 ("Rajasthani", raj, raj)
 DEFINE_LANGUAGE_CODE3 ("Rapanui", rap, rap)
 DEFINE_LANGUAGE_CODE3 ("Rarotongan", rar, rar)
+DEFINE_LANGUAGE_CODE3 ("Tarifit", rif, rif)
 DEFINE_LANGUAGE_CODE3 ("Romance (Other)", roa, roa)
 DEFINE_LANGUAGE_CODE ("Romanian", ro, ron, rum)
 DEFINE_LANGUAGE_CODE3 ("Romany", rom, rom)
diff --git a/localedata/Makefile b/localedata/Makefile
index 79db713925..d601626ffb 100644
--- a/localedata/Makefile
+++ b/localedata/Makefile
@@ -98,6 +98,7 @@ test-input := \
 	pl_PL.UTF-8 \
 	ps_AF.UTF-8 \
 	ro_RO.UTF-8 \
+	rif_MA.UTF-8 \
 	ru_RU.UTF-8 \
 	sah_RU.UTF-8 \
 	sc_IT.UTF-8 \
@@ -268,6 +269,7 @@ LOCALES := \
 	pl_PL.UTF-8 \
 	ps_AF.UTF-8 \
 	ro_RO.UTF-8 \
+	rif_MA.UTF-8 \
 	ru_RU.UTF-8 \
 	sah_RU.UTF-8 \
 	sc_IT.UTF-8 \
diff --git a/localedata/SUPPORTED b/localedata/SUPPORTED
index d768aa4795..ca39131596 100644
--- a/localedata/SUPPORTED
+++ b/localedata/SUPPORTED
@@ -378,6 +378,8 @@ pt_PT/ISO-8859-1 \
 pt_PT@euro/ISO-8859-15 \
 quz_PE/UTF-8 \
 raj_IN/UTF-8 \
+rif_MA/UTF-8 \
+rif_MA.UTF-8/UTF-8 \
 ro_RO.UTF-8/UTF-8 \
 ro_RO/ISO-8859-2 \
 ru_RU.KOI8-R/KOI8-R \
diff --git a/localedata/locales/rif_MA b/localedata/locales/rif_MA
new file mode 100644
index 0000000000..acc50a9d27
--- /dev/null
+++ b/localedata/locales/rif_MA
@@ -0,0 +1,161 @@
+comment_char %
+escape_char /
+
+% This file is part of the GNU C Library and contains locale data.
+% The Free Software Foundation does not claim any copyright interest
+% in the locale data contained in this file.  The foregoing does not
+% affect the license of the GNU C Library as a whole.  It does not
+% exempt you from the conditions of the license if your use would
+% otherwise be governed by that license.
+
+% Tarifit language locale for Morocco
+% Contact: Ilyahoo Proshel
+% Email: ip@ipshel.com
+
+
+LC_IDENTIFICATION
+title      "Tarifit locale for Morocco"
+source     ""
+contact    "Ilyahoo Proshel"
+email      "ip@ipshel.com"
+language   "Tarifit"
+territory  "Morocco"
+revision   "1.5"
+date       "2020-01-25"
+
+category "i18n:2012";LC_IDENTIFICATION
+category "i18n:2012";LC_CTYPE
+category "i18n:2012";LC_COLLATE
+category "i18n:2012";LC_TIME
+category "i18n:2012";LC_NUMERIC
+category "i18n:2012";LC_MONETARY
+category "i18n:2012";LC_MESSAGES
+category "i18n:2012";LC_PAPER
+category "i18n:2012";LC_NAME
+category "i18n:2012";LC_ADDRESS
+category "i18n:2012";LC_TELEPHONE
+category "i18n:2012";LC_MEASUREMENT
+END LC_IDENTIFICATION
+
+LC_CTYPE
+copy "i18n"
+
+translit_start
+include "translit_combining";""
+translit_end
+END LC_CTYPE
+
+LC_COLLATE
+copy "iso14651_t1"
+END LC_COLLATE
+
+LC_TIME
+abday       	"<U004C><U1E25><U0065>";/
+		"<U004C><U0065><U0074>";/
+		"<U0054><U0074><U006C>";/
+		"<U004C><U0061><U0072>";/
+		"<U004C><U0065><U0078>";/
+		"<U004A><U006A><U0065>";/
+		"<U0053><U0062><U0074>"
+day		"<U004C><U1E25><U0065><U0064>";/
+		"<U004C><U0065><U0074><U006E><U0061><U0079><U0065><U006E>";/
+		"<U0054><U0074><U006C><U0061><U0074>";/
+		"<U004C><U0061><U0072><U0062><U0065><U025B>";/
+		"<U004C><U0065><U0078><U006D><U0069><U0073><U0073>";/
+		"<U004A><U006A><U0065><U006D><U025B><U0061>";/
+		"<U0053><U0073><U0065><U0062><U0074>"
+abmon       	"<U0059><U0065><U006E>";/
+         	"<U0046><U0065><U0062>";/
+		"<U004D><U0061><U0072>";/
+           	"<U0059><U0065><U0062>";/
+           	"<U004D><U0061><U0079>";/
+          	"<U0059><U0075><U006E>";/
+          	"<U0059><U0075><U006C>";/
+          	"<U0194><U0075><U0063>";/
+          	"<U0043><U0075><U0074>";/
+          	"<U004B><U1E6D><U0075>";/
+          	"<U004E><U0075><U0076>";/
+          	"<U0044><U0075><U006A>"
+mon         	"<U0059><U0065><U006E><U006E><U0061><U0079><U0065><U0072>";/
+            	"<U0046><U0065><U0062><U0072><U0061><U0079><U0065><U0072>";/
+            	"<U004D><U0061><U0072><U0065><U0073>";/
+            	"<U0059><U0065><U0062><U0072><U0069><U006C>";/
+            	"<U004D><U0061><U0079><U0079><U0075>";/
+            	"<U0059><U0075><U006E><U0079><U0075>";/
+            	"<U0059><U0075><U006C><U0079><U0075><U007A>";/
+            	"<U0194><U0075><U0063><U0074>";/
+            	"<U0043><U0075><U0074><U0065><U006E><U0062><U0065><U0072>";/
+            	"<U004B><U1E6D><U0075><U0062><U0065><U0072>";/
+            	"<U004E><U0075><U0076><U0065><U006D><U0062><U0065><U0072>";/
+            	"<U0044><U0075><U006A><U0065><U006D><U0062><U0065><U0072>"
+d_t_fmt     	"%a %d %b %Y %T %Z"
+d_fmt       	"%d//%m//%y"
+t_fmt       	"%T"
+am_pm       	"<U0073><U0062>";"<U0061><U025B>"
+t_fmt_ampm  	""
+date_fmt    	"%a %e %b %Y %H:%M:%S %Z"
+week    	7;19971130;4
+first_weekday 	2
+END LC_TIME
+
+LC_NUMERIC
+decimal_point 	"."
+thousands_sep 	""
+grouping      	3
+END LC_NUMERIC
+
+LC_MONETARY
+int_curr_symbol		"<U004D><U0041><U0044><U0020>"
+currency_symbol        	"<U0064><U0068>"
+mon_decimal_point      	"."
+mon_thousands_sep      	""
+mon_grouping           	3;3
+positive_sign          	""
+negative_sign          	"-"
+int_frac_digits        	2
+frac_digits           	2
+p_cs_precedes          	1
+p_sep_by_space         	0
+n_cs_precedes          	0
+n_sep_by_space         	0
+p_sign_posn            	1
+n_sign_posn            	1
+END LC_MONETARY
+
+LC_MESSAGES
+yesexpr 	"^[<U002B><U0031><U0079><U0059><U0077><U0057>]"
+noexpr  	"^[<U002D><U0030><U006E><U004E><U006C><U004C>]"
+yesstr 		"<U0057><U0061><U0068>"
+nostr  		"<U004C><U006C><U0061>"
+END LC_MESSAGES
+
+LC_PAPER
+copy "i18n"
+END LC_PAPER
+
+LC_NAME
+name_fmt  "%g%t%f"
+END LC_NAME
+
+LC_ADDRESS
+postal_fmt   "%f%N%a%N%d%N%b%N%s %h %e %r%N%z %T%N%c%N"
+country_name "<U004C><U006D><U0065><U0072><U0072><U0075><U006B>"
+country_ab2  "<U004D><U0041>"
+country_ab3  "<U004D><U0041><U0052>"
+country_num  504
+country_car  "<U004D><U0041>"
+lang_term    "<U0072><U0069><U0066>"
+lang_lib     "<U0072><U0069><U0066>"
+END LC_ADDRESS
+
+LC_TELEPHONE
+tel_int_fmt    "+%c%l"
+tel_dom_fmt	"0%l"
+int_select     "00"
+int_prefix     "212"
+END LC_TELEPHONE
+
+LC_MEASUREMENT
+copy "i18n"
+END LC_MEASUREMENT
+
diff --git a/localedata/rif_MA.UTF-8.in b/localedata/rif_MA.UTF-8.in
new file mode 100644
index 0000000000..014937789f
--- /dev/null
+++ b/localedata/rif_MA.UTF-8.in
@@ -0,0 +1,17 @@
+a
+A
+ḍ
+Ḍ
+ɛ
+Ɛ
+ɣ
+Ɣ
+ḥ
+Ḥ
+ṣ
+Ṣ
+ṭ
+Ṭ
+ʷ
+ẓ
+Ẓ